<?php

class actionContentItemRandom extends cmsAction {

    public function run(){

        if (!$this->request->isAjax()){ cmsCore::error404(); }

        $template = cmsTemplate::getInstance();

        $item_old_id = $this->request->get('item_id');
        $ctype_name = $this->request->get('ctype_name');
        $image_field = $this->request->get('image_field');
        $teaser_field = $this->request->get('teaser_field'); 
        $is_comments = $this->request->get('is_comments');
       
        
        // Отключаем фильтр приватности для тех кому это разрешено
        if (cmsUser::isAllowed($ctype_name, 'view_all')) {
            $this->model->disablePrivacyFilter();
        }

        // Скрываем записи из скрытых родителей (приватных групп и т.п.)
        $this->model->filterHiddenParents();    

        $total_count = $this->model->getContentItemsCount($ctype_name);

        if (!$total_count){
            $result = array('error' => false, 'total' => 0);
            $template->renderJSON($result);
        }

        if ($total_count>1) { // берём случайный id 

            do {    // чтобы 2 раза не выводился одинаковый контент            
                $item_id = mt_rand(1, $total_count);
            } while ($item_id == $item_old_id);

        } else { $item_id = 1; }   
        
        $item = $this->model->getContentItem($ctype_name, $item_id); 
        
        $date = new DateTime($item['date_pub']);                              

        // Формируем и возвращаем результат
        $result = array(
            'error' => false,
            'id' => $item_id,
            'url' => href_to($ctype_name, $item['slug']) . '.html', //ссылка на контент
            'image' => html_image($item[$image_field], big), // ссылка на картинку (возвращает тег img)
            'title' => htmlspecialchars($item['title']), //текст заголовка
            'teaser' => $item[$teaser_field], //текст тизера            
            'url_author' => href_to('users', $item['user']['id']),
            'author' => htmlspecialchars($item['user']['nickname']),    
            'date' => htmlspecialchars($date->format('d.m.Y')), 
            'comments' => $is_comments ? intval($item['comments']) : false                
        );

        $template->renderJSON($result);

    }

}
