<?php

class widgetContentRandom extends cmsWidget {

    public function run(){

        $ctype_id = $this->getOption('ctype_id');
        $image_field = $this->getOption('image_field');
        $teaser_field = $this->getOption('teaser_field');
        $is_show_details = $this->getOption('show_details');

        $model = cmsCore::getModel('content');

        $ctype = $model->getContentType($ctype_id);

        if (!$ctype) { return false; }

        // Отключаем фильтр приватности для тех кому это разрешено
        if (cmsUser::isAllowed($ctype['name'], 'view_all')) {
            $model->disablePrivacyFilter();
        }

        // Скрываем записи из скрытых родителей (приватных групп и т.п.)
        $model->filterHiddenParents();

        $total = $model->getContentItemsCount($ctype['name']); 
        if ($total>0) { $item_id = mt_rand(1, $total); } 
        
        $item = $model->getContentItem($ctype['name'], $item_id);

        $this->links = LANG_WD_CONTENT_RANDOM_REFRESH . '| #refresh" onclick="icms.random.getNext(); return false' ;

        if (!$item) { return false; }

        return array(
            'ctype' => $ctype,
            'image_field' => $image_field,
            'teaser_field' => $teaser_field,
            'is_show_details' => $is_show_details,
            'item' => $item,   
        );

    }

}
