var icms = icms || {};

icms.random = (function ($) {

    //=====================================================================//

    this.getNext = function () {

        $('.rnd_item .loading').show();
        
        var r_data = {
            item_id: $('#rnd_data').data('item-id'),
            ctype_name:   $('#rnd_data').data('ctype-name'),
            image_field:  $('#rnd_data').data('image-field'),
            teaser_field: $('#rnd_data').data('teaser-field'),
            is_comments:  $('#rnd_data').data('is-comments')
        }

        var url = $('#rnd_data').data('url');

        $.post(url, r_data, icms.random.updateData, "json");

        return false;

    }

    //=====================================================================//

    this.updateData = function(result){
        
        if (result == null || typeof(result) == 'undefined' || result.error){
                icms.random.error(result.message);
                return;
            }

        $('.rnd_item a').attr('href', result.url);
        $('.rnd_item .rnd_image a').html(result.image);
        $('.rnd_item .title a').text(result.title);
        $('.rnd_item .info .rnd_teaser').text(result.teaser);
        $('#rnd_data').data('item-id', result.id).attr('data-item-id', result.id);
        $('.rnd_item .info .author').html('<a href="' + result.url_author + '">' + result.author + '</a>' );
        $('.rnd_item .info .date').text(result.date);
        $('.rnd_item .info .comments a').attr('href', result.url+'#comments');
        $('.rnd_item .info .comments a').text(result.comments);

        icms.random.restoreForm();

    }
    
    //=====================================================================//

    this.error = function(message){
        alert(message);
        this.restoreForm();
    }
    
    //=====================================================================//
    
    this.restoreForm = function(){
        
        $('.rnd_item .loading').hide();
    }
    
    //=====================================================================//

	return this;

}).call(icms.random || {},jQuery);
